/*
 * TemplateJDialog.java
 *
 * Created on 1 octobre 2008, 08:26
 */

package org.cocktail.mangue.client.select;

import java.awt.BorderLayout;
import java.awt.Color;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Vector;

import javax.swing.BorderFactory;
import javax.swing.JScrollPane;
import javax.swing.ListSelectionModel;
import javax.swing.SwingConstants;

import org.cocktail.application.client.swing.TableSorter;
import org.cocktail.application.client.swing.ZEOTable;
import org.cocktail.application.client.swing.ZEOTableModel;
import org.cocktail.application.client.swing.ZEOTableModelColumn;
import org.cocktail.mangue.common.utilities.CocktailIcones;
import org.cocktail.mangue.modele.grhum.EOGrade;

import com.webobjects.eointerface.EODisplayGroup;

/**
 *
 * @author  cpinsard
 */
public class GradeSelectView extends javax.swing.JDialog {

    protected EODisplayGroup eod;
	protected ZEOTable myEOTable;
	protected ZEOTableModel myTableModel;
	protected TableSorter myTableSorter;

    
    /** Creates new form TemplateJDialog */
    public GradeSelectView(java.awt.Frame parent, boolean modal, EODisplayGroup displayGroup) {
        super(parent, modal);

        eod = displayGroup;
        
        initComponents();
        initGui();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */

    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        viewTable = new javax.swing.JPanel();
        btnSelectionner = new javax.swing.JButton();
        btnAnnuler = new javax.swing.JButton();
        tfFiltreCode = new javax.swing.JTextField();
        tfFiltreLbelleCourt = new javax.swing.JTextField();
        tfFiltreLibelleLong = new javax.swing.JTextField();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("Sélection d'un corps");
        setResizable(false);

        viewTable.setBorder(javax.swing.BorderFactory.createEtchedBorder());
        viewTable.setLayout(new java.awt.BorderLayout());

        btnSelectionner.setToolTipText("Valider la sélection");
        btnSelectionner.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnSelectionnerActionPerformed(evt);
            }
        });

        btnAnnuler.setToolTipText("Annuler");

        tfFiltreCode.setFont(new java.awt.Font("Tahoma", 0, 10));

        tfFiltreLbelleCourt.setFont(new java.awt.Font("Tahoma", 0, 10));

        tfFiltreLibelleLong.setFont(new java.awt.Font("Tahoma", 0, 10));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(tfFiltreCode, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 55, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(tfFiltreLbelleCourt, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 130, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(tfFiltreLibelleLong, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 318, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 757, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(btnAnnuler, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 51, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(btnSelectionner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 48, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(tfFiltreCode, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(tfFiltreLbelleCourt, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(tfFiltreLibelleLong, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 18, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(viewTable, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 628, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(btnSelectionner, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(btnAnnuler, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(23, 23, 23))
        );

        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setBounds((screenSize.width-793)/2, (screenSize.height-751)/2, 793, 751);
    }// </editor-fold>//GEN-END:initComponents

private void btnSelectionnerActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnSelectionnerActionPerformed

    dispose();

}//GEN-LAST:event_btnSelectionnerActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
            	GradeSelectView dialog = new GradeSelectView(null, true, null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAnnuler;
    private javax.swing.JButton btnSelectionner;
    protected javax.swing.JTextField tfFiltreCode;
    protected javax.swing.JTextField tfFiltreLbelleCourt;
    protected javax.swing.JTextField tfFiltreLibelleLong;
    private javax.swing.JPanel viewTable;
    // End of variables declaration//GEN-END:variables

    
    
    
    public ZEOTable getMyEOTable() {
		return myEOTable;
	}

	public javax.swing.JButton getBtnAnnuler() {
		return btnAnnuler;
	}

	public void setBtnAnnuler(javax.swing.JButton btnAnnuler) {
		this.btnAnnuler = btnAnnuler;
	}

	public javax.swing.JTextField getTfFiltreCode() {
		return tfFiltreCode;
	}

	public void setTfFiltreCode(javax.swing.JTextField tfFiltreCode) {
		this.tfFiltreCode = tfFiltreCode;
	}

	public javax.swing.JTextField getTfFiltreLbelleCourt() {
		return tfFiltreLbelleCourt;
	}

	public void setTfFiltreLbelleCourt(javax.swing.JTextField tfFiltreLbelleCourt) {
		this.tfFiltreLbelleCourt = tfFiltreLbelleCourt;
	}

	public javax.swing.JTextField getTfFiltreLibelleLong() {
		return tfFiltreLibelleLong;
	}

	public void setTfFiltreLibelleLong(javax.swing.JTextField tfFiltreLibelleLong) {
		this.tfFiltreLibelleLong = tfFiltreLibelleLong;
	}

	public javax.swing.JButton getBtnSelectionner() {
		return btnSelectionner;
	}

	public void setBtnSelectionner(javax.swing.JButton btnSelectionner) {
		this.btnSelectionner = btnSelectionner;
	}

	public void setMyEOTable(ZEOTable myEOTable) {
		this.myEOTable = myEOTable;
	}
        
    private void initGui() {
        
    	setTitle("Sélection d'un GRADE");
    	
    	btnSelectionner.setIcon(CocktailIcones.ICON_VALID);
        btnAnnuler.setIcon(CocktailIcones.ICON_CANCEL);
        
       	Vector myCols = new Vector();

		ZEOTableModelColumn col = new ZEOTableModelColumn(eod, EOGrade.C_GRADE_KEY, "Code", 50);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOGrade.LC_GRADE_KEY, "Libellé Court", 125);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOGrade.LL_GRADE_KEY, "Libellé Long", 315);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOGrade.C_CATEGORIE_KEY, "Cat", 30);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOGrade.ECHELLE_KEY, "Ech", 30);
		col.setAlignment(SwingConstants.CENTER);
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOGrade.D_OUVERTURE_KEY, "Ouverture", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setColumnClass(java.util.Date.class);
		col.setFormatDisplay((DateFormat)new SimpleDateFormat("dd/MM/yyyy"));
		myCols.add(col);
		col = new ZEOTableModelColumn(eod, EOGrade.D_FERMETURE_KEY, "Fermeture", 75);
		col.setAlignment(SwingConstants.CENTER);
		col.setColumnClass(java.util.Date.class);
		col.setFormatDisplay((DateFormat)new SimpleDateFormat("dd/MM/yyyy"));
		myCols.add(col);

		myTableModel = new ZEOTableModel(eod, myCols);
		myTableSorter = new TableSorter(myTableModel);

		myEOTable = new ZEOTable(myTableSorter);
		//myEOTable.addListener(myListenerContrat);
		myTableSorter.setTableHeader(myEOTable.getTableHeader());		

		myEOTable.setBackground(new Color(230, 230, 230));
		myEOTable.setSelectionBackground(new Color(127,155,165));
		myEOTable.setSelectionMode(ListSelectionModel.MULTIPLE_INTERVAL_SELECTION);
		
		viewTable.setLayout(new BorderLayout());
		viewTable.setBorder(BorderFactory.createEmptyBorder(2,2,2,2));
		viewTable.removeAll();
		viewTable.add(new JScrollPane(myEOTable), BorderLayout.CENTER);

    }
}
